'use strict'

/**
 * Module dependencies.
 */

var integration = require('@segment/analytics.js-integration')

/**
 * Expose `Salesforce DMP` integration.
 */

var SalesforceDMP = module.exports = integration('Salesforce DMP')
  .option('confId', '')
  .tag('init', '<script src="//cdn.krxd.net/controltag/{{ confId }}.js">')
  .tag('usermatch', '<img src="https://beacon.krxd.net/usermatch.gif?partner=segment_io&partner_uid={{ userId }}">')

SalesforceDMP.prototype.initialize = function () {
  // We require a confid to run this integration.
  if (!this.options.confId) return
  var self = this

  window.Krux||((window.Krux=function(){window.Krux.q.push(arguments)}).q=[]) //eslint-disable-line

  this.load('init', function () {
    self.ready()
  })
}

SalesforceDMP.prototype.loaded = function () {
  return !!(window.Krux && window.Krux.q && window.Krux.ns)
}

SalesforceDMP.prototype.identify = function (identify) {
  var userId = identify.userId() || identify.anonymousId()
  this.load('usermatch', {userId: userId})
}
