'use strict'

var Analytics = require('@segment/analytics.js-core').constructor
var integration = require('@segment/analytics.js-integration')
var tester = require('@segment/analytics.js-integration-tester')
var sandbox = require('@segment/clear-env')
var SalesforceDMP = require('../lib/')

describe('Salesforce DMP', function () {
  var analytics
  var salesforceDMP
  var options = {
    confId: 'rw1to29bb'
  }

  beforeEach(function () {
    analytics = new Analytics()
    salesforceDMP = new SalesforceDMP(options)
    analytics.use(SalesforceDMP)
    analytics.use(tester)
    analytics.add(salesforceDMP)
  })

  afterEach(function () {
    analytics.restore()
    analytics.reset()
    salesforceDMP.reset()
    sandbox()
  })

  it('should have the right settings', function () {
    analytics.compare(SalesforceDMP, integration('Salesforce DMP')
      .option('confId', ''))
  })

  describe('before loading', function () {
    beforeEach(function () {
      analytics.stub(salesforceDMP, 'load')
    })

    describe('#initialize', function () {
      it('should call #load', function () {
        analytics.initialize()
        analytics.page()
        analytics.called(salesforceDMP.load)
      })
    })
  })
})
